




#include "m_pd.h"  
 
static t_class *getcanvas_class;  
 
typedef struct _getcanvas {  
  t_object  x_obj; 
  t_glist *x_glist;  
} t_getcanvas;  

void getcanvas_bang(t_getcanvas *x)  
{
    t_canvas *canvas=glist_getcanvas(x->x_glist);
    char name[100];
    sprintf(name, "%lx",canvas); 
    outlet_symbol(x->x_obj.ob_outlet, gensym(name));  
}
/*
void getcanvas_byclass(t_getcanvas *x, t_symbol *cnv)  
{
    t_canvas *canvas=pd_findbyclass(cnv, getcanvas_class);
    char name[100];
    sprintf(name, "%lx",canvas); 
    outlet_symbol(x->x_obj.ob_outlet, gensym(name)); 
}
*/ 
void *getcanvas_new(void)  
{  
  t_getcanvas *x = (t_getcanvas *)pd_new(getcanvas_class);  
  x->x_glist = (t_glist *) canvas_getcurrent();
  outlet_new(&x->x_obj, &s_symbol );
  return (void *)x;  
}  
 
void getcanvas_setup(void) {  
  getcanvas_class = class_new(gensym("getcanvas"),  
        (t_newmethod)getcanvas_new,  
        0, sizeof(t_getcanvas),  
        CLASS_DEFAULT, 0);  
  class_addbang(getcanvas_class, getcanvas_bang);
//  class_addsymbol(getcanvas_class, getcanvas_byclass);  
} 
